#ifndef __TSTRING_H_
#define __TSTRING_H_

#include <string.h>

class TString {
   private:
      char *m_String;

   public:
      TString(void);
      ~TString();
      void cat(const char *str);
      void clean(void);
      char *getData(void);
      char *cutData(void);
/*
      void operator  = (const char *str);
      void operator  = (TString& s);
      void operator  = (const char ch);
*/
      void operator += (const char *str);
      void operator += (TString& s);
      void operator += (const char ch);
      int  operator == (const char *str);
      int  operator == (TString& s);
      int  operator == (const char ch);
};

/*
inline void TString::operator = (const char *str) {
   this->clean();
   this->cat( str );
}

inline void TString::operator = (TString& s) {
   this->clean();
   this->cat( s.getData() );
}

inline void TString::operator = (const char ch) {
   char temp[2] = {'\0','\0'};
   this->clean();
   temp[0] = ch;
   this->cat( temp );
}
*/

inline void TString::operator += (const char *str) {
   this->cat( str );
}

inline void TString::operator += (TString& s) {
   this->cat( s.getData() );
}

inline void TString::operator += (const char ch) {
   char temp[2] = {'\0','\0'};
   temp[0] = ch;
   this->cat( temp );
}

inline int TString::operator == (const char *str) {
   return strcmp( this->getData(), str );
}

inline int TString::operator == (TString& s) {
   return strcmp( this->getData(), s.getData() );
}

inline int TString::operator == (const char ch) {
   return m_String[0] - ch;
}

#endif
