#ifndef __TADVMSGBOX_H_
#define __TADVMSGBOX_H_

#include "default.h"

class TTextBox : public TScroller {
   private:
      int m_nCols;
      int m_nRows;
      TStringCollection *m_Text;

   public:
      TTextBox(const TRect& bounds,
               const char *sText,
               const int nCols,
               const int nRows,
               TScrollBar *hSB,
               TScrollBar *vSB);
      virtual void draw(void);
};

class TAdvMsgBox : public TWindow {
   private:
      int m_nCols;
      int m_nRows;
      TRect& calcRect(const char *sText);

   public:
      TAdvMsgBox(const char *sTitle, const char *sText);
};

#endif
